// example_array_member.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#include <stdio.h>
#include <gct/cont_array.h>

struct myitem
{
  int a;
};

GCT_CONTAINER_TYPES(mystructarray, ARRAY, struct myitem, 16)
GCT_CONTAINER_FCNS(mystructarray, ARRAY, static, mystructfunc);

GCT_CONTAINER_KEY_TYPES(mystructarray, MEMBER, SCALAR, a)
GCT_CONTAINER_KEY_FCNS(mystructarray, ARRAY, static, mystructfunc, a);

int main()
{
  mystructarray_root_t array;
  struct myitem items[3] = { { .a = 7 }, { .a = 11 }, { .a = 5 } };

  mystructfunc_init(&array);
  mystructfunc_pushback_array(&array, items, 3);

  printf("index :%i\n", mystructfunc_lookup(&array, 11));

  return 0;
}
