// example_array_ptr.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#include <stdio.h>
#include <gct/cont_array.h>

struct myitem
{
  int a;
};

GCT_CONTAINER_TYPES(myptrarray, ARRAY, struct myitem *, 16)
GCT_CONTAINER_FCNS(myptrarray, ARRAY, static, myptrfunc);

GCT_CONTAINER_KEY_TYPES(myptrarray, PTR, SCALAR, a)
GCT_CONTAINER_KEY_FCNS(myptrarray, ARRAY, static, myptrfunc, a);

int main()
{
  myptrarray_root_t array;
  struct myitem items[3] = { { .a = 7 }, { .a = 11 }, { .a = 5 } };

  myptrfunc_init(&array);
  myptrfunc_pushback(&array, &items[0]);
  myptrfunc_pushback(&array, &items[1]);
  myptrfunc_pushback(&array, &items[2]);

  printf("index :%i\n", myptrfunc_lookup(&array, 11));

  return 0;
}
