// example_container_refcount.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#define GCT_CONFIG_ATOMIC_PTHREAD_MUTEX

#include <stdio.h>
#include <gct/cont_slist.h>
#include <gct/object_refcount.h>

GCT_OBJECT_TYPES     (myobj, REFCOUNT, struct myitem);
GCT_OBJECT_PROTOTYPES(myobj, static, myobjfunc);

struct myitem
{
  _GCT_CONTAINER_ENTRY_TYPE(SLIST)	list_entry;
  myobj_entry_t			obj_entry;
  const char			*data;
};

#define GCT_CONTAINER_OBJ_mylist myobjfunc

GCT_CONTAINER_TYPES     (mylist, SLIST, struct myitem, list_entry);
GCT_CONTAINER_PROTOTYPES(mylist, static, myfunc);

static GCT_OBJECT_CONSTRUCTOR(myobj)
{
  obj->data = va_arg(ap, const char *);

  return 0;
}

static GCT_OBJECT_DESTRUCTOR(myobj)
{
  printf("%s droped\n", obj->data);
}

GCT_OBJECT_FCNS   (myobj, REFCOUNT, static, myobjfunc, obj_entry);
GCT_CONTAINER_FCNS(mylist, SLIST, static, myfunc);

#define myobjfunc_new(...) myobjfunc_new(NULL, __VA_ARGS__)

int main()
{
  mylist_root_t	list;

  struct myitem *a;

  myfunc_init(&list);

  a = myobjfunc_new("foo");
  myfunc_push(&list, a);
  myobjfunc_refdrop(a);

  a = myobjfunc_new("bar");
  myfunc_push(&list, a);
  myobjfunc_refdrop(a);

  puts("clear");

  myfunc_clear(&list);

  return 0;
}

