// example_dlist.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#include <stdio.h>
#include <gct/cont_dlist.h>

struct myitem
{
  _GCT_CONTAINER_ENTRY_TYPE(DLIST)	list_entry;
  const char			*data;
};

GCT_CONTAINER_TYPES(mylist, DLIST, struct myitem, list_entry);
GCT_CONTAINER_FCNS(mylist, DLIST, static, myfunc);

int main()
{
  mylist_root_t	list;

  struct myitem a = { .data = "foo" };
  struct myitem b = { .data = "bar" };

  myfunc_init(&list);
  myfunc_push(&list, &a);
  myfunc_push(&list, &b);

  puts(myfunc_pop(&list)->data);
  puts(myfunc_pop(&list)->data);

  return 0;
}

