// example_hashlist.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#include <stdio.h>
#include <gct/cont_hashlist.h>

struct myitem
{
  _GCT_CONTAINER_ENTRY_TYPE(HASHLIST)        hash_entry;
  const char                            *data;
};

GCT_CONTAINER_TYPES    (myhash, HASHLIST, struct myitem, hash_entry, 11);
GCT_CONTAINER_KEY_TYPES(myhash, PTR, STRING, data);

GCT_CONTAINER_FCNS    (myhash, HASHLIST, static, myfunc, data);
GCT_CONTAINER_KEY_FCNS(myhash, HASHLIST, static, myfunc, data);

int main()
{
  myhash_root_t hash;

  struct myitem a = { .data = "foo" };
  struct myitem b = { .data = "bar" };

  myfunc_init(&hash);
  myfunc_push(&hash, &a);
  myfunc_push(&hash, &b);

  assert(myfunc_lookup(&hash, "foo") == &a);
  assert(myfunc_lookup(&hash, "bar") == &b);

  return 0;
}

