// example_intro.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#include <stdio.h>
#include <gct/cont_slist.h>

struct myitem
{
  _GCT_CONTAINER_ENTRY_TYPE(SLIST)   list_entry;
  const char                    *data;
};

GCT_CONTAINER_TYPES(mylist, SLIST, struct myitem, list_entry);
GCT_CONTAINER_FCNS(mylist, SLIST, static, myfunc);

int main()
{
  mylist_root_t list;

  struct myitem a = { .data = "foo" };
  struct myitem b = { .data = "bar" };

  myfunc_init(&list);

  myfunc_push(&list, &a);
  myfunc_push(&list, &b);

  puts(myfunc_pop(&list)->data);
  puts(myfunc_pop(&list)->data);

  return 0;
}

