// example_iterate.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#include <stdio.h>
#include <gct/cont_slist.h>

struct myitem
{
  _GCT_CONTAINER_ENTRY_TYPE(SLIST)	list_entry;
  const char			*data;
};

GCT_CONTAINER_TYPES(mylist, SLIST, struct myitem, list_entry);
GCT_CONTAINER_FCNS(mylist, SLIST, static, myfunc);

GCT_CONTAINER_ITERATOR(mylist, myiter_func)
{
  char *str = va_arg(ap, char *);

  printf("%s %s\n", str, item->data);
  return 0;
}

int main()
{
  mylist_root_t	list;

  struct myitem a = { .data = "foo" };
  struct myitem b = { .data = "bar" };

  myfunc_init(&list);
  myfunc_push(&list, &a);
  myfunc_push(&list, &b);

  myfunc_foreach(&list, myiter_func, "data:");

  return 0;
}

