// example_lock.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#include <gct/lock_pthread_mutex.h>
#include <gct/cont_slist.h>

struct myitem
{
  _GCT_CONTAINER_ENTRY_TYPE(SLIST)   list_entry;
  const char                    *data;
};

#define GCT_CONTAINER_LOCK_mylist PTHREAD_MUTEX

GCT_CONTAINER_TYPES       (mylist, SLIST, struct myitem, list_entry);
GCT_CONTAINER_FCNS       (mylist, SLIST, static, myfunc);
GCT_CONTAINER_NOLOCK_FCNS(mylist, SLIST, static, myfunc_nolock);

int main()
{
  mylist_root_t list;

  struct myitem a = { .data = "foo" };
  struct myitem b = { .data = "bar" };

  myfunc_init(&list);

  myfunc_wrlock(&list);          /* single write lock batched accesses */
  myfunc_nolock_push(&list, &a);
  myfunc_nolock_push(&list, &b);
  myfunc_unlock(&list);

  myfunc_pop(&list);             /* multiple write locked accesses */
  myfunc_pop(&list);

  return 0;
}
