// example_obj_refcount.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#define GCT_CONFIG_ATOMIC_PTHREAD_MUTEX

#include <stdio.h>
#include <gct/object_refcount.h>

GCT_OBJECT_TYPES     (myobj, REFCOUNT, struct myitem);
GCT_OBJECT_PROTOTYPES(myobj, static, myobjfunc);

struct myitem
{
  myobj_entry_t			obj_entry;
  const char			*data;
};

#define GCT_CONTAINER_OBJ_mylist myobjfunc

static GCT_OBJECT_CONSTRUCTOR(myobj)
{
  obj->data = va_arg(ap, const char *);

  return 0;
}

static GCT_OBJECT_DESTRUCTOR(myobj)
{
  printf("%s droped\n", obj->data);
}

GCT_OBJECT_FCNS   (myobj, REFCOUNT, static, myobjfunc, obj_entry);

int main()
{
  struct myitem *a;

  a = myobjfunc_new(NULL, "foo");
  assert(myobjfunc_refcount(a) == 1);

  myobjfunc_refnew(a);
  assert(myobjfunc_refcount(a) == 2);

  myobjfunc_refdrop(a);
  assert(myobjfunc_refcount(a) == 1);

  myobjfunc_refdrop(a);

  return 0;
}

