// example_ring.c GCT example
// Copyright Alexandre Becoulet (C) 2009,
// Released under the GPL v3, see COPYING

#include <stdio.h>
#include <gct/cont_ring.h>

struct myitem
{
  const char			*data;
};

GCT_CONTAINER_TYPES(myring, RING, struct myitem, 16)
GCT_CONTAINER_FCNS(myring, RING, static, myfunc);

int main()
{
  myring_root_t ring;

  struct myitem a = { .data = "foo" };
  struct myitem b = { .data = "bar" };

  myfunc_init(&ring);
  myfunc_push(&ring, a);
  myfunc_push(&ring, b);

  puts(myfunc_pop(&ring).data);
  puts(myfunc_pop(&ring).data);

  return 0;
}

