/* -*- c -*-

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
    02110-1301 USA

    Copyright Alexandre Becoulet <alexandre.becoulet@free.fr> (C) 2009

    Generic lookup functions set based on container FOREACH iteration

*/

#ifndef _GCT_CONT_LOOKUP_H_
#define _GCT_CONT_LOOKUP_H_

/* backslash-region-begin */
#define _GCT_CONT_REMOVE_KEY_FCNS(attr, name, algo, prefix,
			          lockname, keyfield)
/* backslash-region-end */

#if 0
attr GCT_CONT_REMOVE_KEY_PROTOTYPE(name, prefix, keyfield)
{
  name##_index_t idx = prefix##_lookup(root, value); /* FIXME should not use prefix here */
  gct_err_t err = -1;

  if (idx != name##_null_index)
    {
/*      prefix##_remove(root, idx); FIXME */
      _GCT_CONT_REFDROP(name, prefix##_get(root, idx)); /* FIXME should not use prefix here */
      err = 0;
    }

  return err;
}
#endif

/* backslash-region-begin */
#define   _GCT_CONT_LOOKUP_FCNS(attr, name, algo, prefix,
                                lockname, keyfield)

attr GCT_CONT_LOOKUP_PROTOTYPE(name, prefix, keyfield)
{
  name##_index_t        res = name##_null_index;

  _GCT_LOCK_RDLOCK(lockname, &root->lock);

  { _GCT_CPP_CONCAT(_GCT_CONT_, algo, _FOREACH)(name, root,
  {
    if (!_GCT_CONT_COMPARE_FIELD_ARG(name, keyfield, item, value))
      {
        _GCT_CONT_REFNEW(name, item);
        res = index;
        goto found;
      }
  }); }

 found:
  _GCT_LOCK_UNLOCK(lockname, &root->lock);

  return res;
}

attr GCT_CONT_LOOKUP_LAST_PROTOTYPE(name, prefix, keyfield)
{
  name##_index_t        res = name##_null_index;

  _GCT_LOCK_RDLOCK(lockname, &root->lock);

  { _GCT_CPP_CONCAT(_GCT_CONT_, algo, _FOREACH_REVERSE)(name, root,
  {
    if (!_GCT_CONT_COMPARE_FIELD_ARG(name, keyfield, item, value))
      {
        _GCT_CONT_REFNEW(name, item);
        res = index;
        goto found;
      }
  }); }

 found:
  _GCT_LOCK_UNLOCK(lockname, &root->lock);

  return res;
}

attr GCT_CONT_LOOKUP_NEXT_PROTOTYPE(name, prefix, keyfield)
{
  name##_index_t        res = name##_null_index;

  _GCT_LOCK_RDLOCK(lockname, &root->lock);

  { _GCT_CPP_CONCAT(_GCT_CONT_, algo, _FOREACH_FROM)(name, root, index,
  {
    if (!_GCT_CONT_COMPARE_FIELD_ARG(name, keyfield, item, value))
      {
        _GCT_CONT_REFNEW(name, item);
        res = index;
        goto found;
      }
  }); }

 found:
  _GCT_LOCK_UNLOCK(lockname, &root->lock);

  return res;
}

attr GCT_CONT_LOOKUP_PREV_PROTOTYPE(name, prefix, keyfield)
{
  name##_index_t        res = name##_null_index;

  _GCT_LOCK_RDLOCK(lockname, &root->lock);

  { _GCT_CPP_CONCAT(_GCT_CONT_, algo, _FOREACH_REVERSE_FROM)(name, root, index,
  {
    if (!_GCT_CONT_COMPARE_FIELD_ARG(name, keyfield, item, value))
      {
        _GCT_CONT_REFNEW(name, item);
        res = index;
        goto found;
      }
  }); }

 found:
  _GCT_LOCK_UNLOCK(lockname, &root->lock);

  return res;
}

_GCT_CONT_REMOVE_KEY_FCNS(attr, name, algo, prefix,
                                lockname, keyfield)
/* backslash-region-end */


#endif

