/*

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
    02110-1301 USA

    Copyright Alexandre Becoulet <alexandre.becoulet@free.fr> (C) 2009

    Dummy lock for container testing.
*/

#ifndef _GCT_LOCK_TEST_H_
#define _GCT_LOCK_TEST_H_

#include <gct/_platform.h>
#include <gct/_cont_access.h>

typedef volatile _GCT_INT _gct_lock_TEST_type_t;

#define _gct_lock_TEST_initializer     { 0 }
#define _GCT_LOCK_TEST_STATIC_INIT 1
#define _GCT_LOCK_TEST_SPINNING 0
#define _GCT_LOCK_TEST_READ_WRITE 0
#define _GCT_LOCK_TEST_RECURSIVE 0

_GCT_INTERNAL gct_err_t
_gct_lock_TEST_init(_gct_lock_TEST_type_t *lock)
{
  *lock = 0;
  return 0;
}

_GCT_INTERNAL void
_gct_lock_TEST_destroy(_gct_lock_TEST_type_t *lock)
{
  _GCT_ASSERT(*lock == 0);
}

_GCT_INTERNAL void
_gct_lock_TEST_wrlock(_gct_lock_TEST_type_t *lock)
{
  _GCT_ASSERT(*lock == 0);
  *lock = 1;
}

_GCT_INTERNAL void
_gct_lock_TEST_rdlock(_gct_lock_TEST_type_t *lock)
{
  _GCT_ASSERT(*lock == 0);
  *lock = 2;
}

_GCT_INTERNAL void
_gct_lock_TEST_unlock(_gct_lock_TEST_type_t *lock)
{
  _GCT_ASSERT(*lock > 0);
  *lock = 0;
}

#endif

